//+------------------------------------------------------------------+
//| 3 ducks indicator      version 1                                 |
//|                                                                  |
//|      The indicator follows the rules of original 3 ducks system. |
//|      Indicator status is shown in the right upper corner of the  |
//|      chart. When all 3 timeframes have the same color, sell or   |
//|      buy.                                                        |
//|      Indicator also contains an audible alarm.                   |
//|      Indicator position in the window can be adjusted.           |
//|                                                                  |
//|                   by Rocroy, 3-22-2008                           |
//|                                                                  |
//+------------------------------------------------------------------+

#property indicator_chart_window

extern color ColorUpGood = Blue;
extern color ColorDownGood = Red;
extern int   Left_position = 0;
extern bool  SoundON=false;
extern int   Number_of_Alarms = 5;

static int   alertTag, alertcount;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorShortName("3 Ducks");
   alertcount = Number_of_Alarms;
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectsDeleteAll(0,OBJ_LABEL); 
   ObjectDelete("heading"); ObjectDelete("M5"); ObjectDelete("H1"); ObjectDelete("H4"); 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {    
    
    //m5 data
    double m5ma = iMA(NULL,PERIOD_M5,60,0,MODE_SMA,PRICE_CLOSE,0);

    //h1 data
    double h1ma = iMA(NULL,PERIOD_H1,60,0,MODE_SMA,PRICE_CLOSE,0);

    //h4 data
    double h4ma = iMA(NULL,PERIOD_H4,60,0,MODE_SMA,PRICE_CLOSE,0);
    
    //define color
    color color_m5, color_h1, color_h4;
    
    //define string
    string arrow_m5, arrow_h1, arrow_h4;
        

    //m5 up trend
    if (m5ma < Bid ) { color_m5 = ColorUpGood; }
    
    //m5 down trend
    if (m5ma > Bid ) { color_m5 = ColorDownGood; }

    //h1 up trend
    if (h1ma < Bid ) { color_h1 = ColorUpGood; }
    
    //h1 down trend
    if (h1ma > Bid ) { color_h1 = ColorDownGood; }

    //h4 up trend
    if (h4ma < Bid ) { color_h4 = ColorUpGood; }
    
    //h4 down trend
    if (h4ma > Bid ) { color_h4 = ColorDownGood; }
    
    
    //Heading           
    ObjectCreate("heading", OBJ_LABEL, 0, 0, 0);
        ObjectSetText("heading","3 Ducks",8, "Segoe UI", color_m5);
        ObjectSet("heading", OBJPROP_XDISTANCE, 200+Left_position);
        ObjectSet("heading", OBJPROP_YDISTANCE, 0);
        
    //Signal Labels           
    ObjectCreate("M5", OBJ_LABEL, 0, 0, 0);//M5 SIGNAL
        ObjectSetText("M5","M5",8, "Segoe UI", color_m5);
        ObjectSet("M5", OBJPROP_XDISTANCE, 200+Left_position);
        ObjectSet("M5", OBJPROP_YDISTANCE, 15);
        
    ObjectCreate("H1", OBJ_LABEL, 0, 0, 0);//H1 SIGNAL
        ObjectSetText("H1","H1",8, "Segoe UI", color_h1);
        ObjectSet("H1", OBJPROP_CORNER, 0);
        ObjectSet("H1", OBJPROP_XDISTANCE, 225+Left_position);
        ObjectSet("H1", OBJPROP_YDISTANCE, 15);
        
    ObjectCreate("H4", OBJ_LABEL, 0, 0, 0);//H4 SIGNAL
        ObjectSetText("H4","H4",8, "Segoe UI", color_h4);
        ObjectSet("H4", OBJPROP_CORNER, 0);
        ObjectSet("H4", OBJPROP_XDISTANCE, 250+Left_position);
        ObjectSet("H4", OBJPROP_YDISTANCE, 15);

   
      if (m5ma < Bid) { arrow_m5 = "5"; }
      if (m5ma > Bid) { arrow_m5 = "6"; }

      if (h1ma < Bid) { arrow_h1 = "5"; }
      if (h1ma > Bid) { arrow_h1 = "6"; }

      if (h4ma < Bid) { arrow_h4 = "5"; }
      if (h4ma > Bid) { arrow_h4 = "6"; }

      
      //arrow m5
      ObjectCreate("ObjLabel9a", OBJ_LABEL, 0, 0, 0);
        ObjectSetText("ObjLabel9a",arrow_m5,8, "Webdings", color_m5);
        ObjectSet("ObjLabel9a", OBJPROP_XDISTANCE, 200+Left_position);
        ObjectSet("ObjLabel9a", OBJPROP_YDISTANCE, 23);
        
      //arrow m30
      ObjectCreate("ObjLabel10a", OBJ_LABEL, 0, 0, 0);
        ObjectSetText("ObjLabel10a",arrow_h1,8, "Webdings", color_h1);
        ObjectSet("ObjLabel10a", OBJPROP_XDISTANCE, 225+Left_position);
        ObjectSet("ObjLabel10a", OBJPROP_YDISTANCE, 23);
    
      //arrow m5
      ObjectCreate("ObjLabel11a", OBJ_LABEL, 0, 0, 0);
        ObjectSetText("ObjLabel11a",arrow_h4,8, "Webdings", color_h4);
        ObjectSet("ObjLabel11a", OBJPROP_XDISTANCE, 250+Left_position);
        ObjectSet("ObjLabel11a", OBJPROP_YDISTANCE, 23);        
        
// alarms
      
      if ( color_m5 != color_h1 || color_h1 != color_h4 ) alertcount = Number_of_Alarms;
      
      if (SoundON==true && color_m5 == color_h1 && color_h1 == color_h4 &&
         alertcount>0 && alertTag!=TimeMinute(TimeCurrent()) )
      {
         Alert(" 3 Ducks in a row! ",Symbol());
         alertTag = TimeMinute(TimeCurrent());
         if (alertcount > 0) alertcount--;
      }
      
        
//----
    return(0); 
//----
} 

//+------------------------------------------------------------------+